// (c) 2002 by Jrn Loviscach

#if !defined(PIXELPATH_H)
#define PIXELPATH_H

#include <stdio.h>
#include <deque>
#include "bitmap.h"

class PixelPath  
{
	public:
	PixelPath();
	virtual ~PixelPath();
	int Trace(Bitmap& bmp, int channel, double depthDiff);
	void Unframe();
	void ConformDirection();
	int GetLength() const { assert(hasPath); return pixelQueue.size(); }
	int GetX(int i) const { assert(hasPath); return pixelQueue[i].x; }
	int GetY(int i) const { assert(hasPath); return pixelQueue[i].y; }
	int GetInvD(int i) const { assert(hasPath); return pixelQueue[i].invD; }

	private:
	bool hasPath;
	struct Pixel
	{
		int x;
		int y;
		int invD;
		Pixel(int x_, int y_, int invD_) : x(x_), y(y_), invD(invD_) {}
	};
	std::deque<Pixel> pixelQueue;
};

#endif